com.amazonaws.services.codebuild.model

## Class ProjectArtifacts

- java.lang.Object
- - com.amazonaws.services.codebuild.model.ProjectArtifacts

All Implemented Interfaces:
  Serializable, Cloneable

    public class ProjectArtifacts
    extends Object
    implements Serializable, Cloneable

Information about the build project's build output artifacts.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`ProjectArtifacts()`

### Method Summary

All Methods Instance Methods Concrete Methods
`ProjectArtifacts` `clone()`
`boolean` `equals(Object obj)`
`String` `getLocation()` Information about the build output artifact location, as follows:
`String` `getName()` Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:
`String` `getNamespaceType()` Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:
`String` `getPackaging()` The type of build output artifact to create, as follows:
`String` `getPath()` Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:
`String` `getType()` The build output artifact's type.
`int` `hashCode()`
`void` `setLocation(String location)` Information about the build output artifact location, as follows:
`void` `setName(String name)` Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:
`void` `setNamespaceType(ArtifactNamespace namespaceType)` Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:
`void` `setNamespaceType(String namespaceType)` Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:
`void` `setPackaging(ArtifactPackaging packaging)` The type of build output artifact to create, as follows:
`void` `setPackaging(String packaging)` The type of build output artifact to create, as follows:
`void` `setPath(String path)` Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:
`void` `setType(ArtifactsType type)` The build output artifact's type.
`void` `setType(String type)` The build output artifact's type.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`ProjectArtifacts` `withLocation(String location)` Information about the build output artifact location, as follows:
`ProjectArtifacts` `withName(String name)` Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:
`ProjectArtifacts` `withNamespaceType(ArtifactNamespace namespaceType)` Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:
`ProjectArtifacts` `withNamespaceType(String namespaceType)` Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:
`ProjectArtifacts` `withPackaging(ArtifactPackaging packaging)` The type of build output artifact to create, as follows:
`ProjectArtifacts` `withPackaging(String packaging)` The type of build output artifact to create, as follows:
`ProjectArtifacts` `withPath(String path)` Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:
`ProjectArtifacts` `withType(ArtifactsType type)` The build output artifact's type.
`ProjectArtifacts` `withType(String type)` The build output artifact's type.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ProjectArtifacts

    public ProjectArtifacts()

### Method Detail

#### setType

    public void setType(String type)

The build output artifact's type. Valid values include:

- `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

- `NO_ARTIFACTS`: The build project will not produce any build output.

- `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Parameters:
  `type` - The build output artifact's type. Valid values include:

  - `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

  - `NO_ARTIFACTS`: The build project will not produce any build output.

  - `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

See Also:
  `ArtifactsType`

#### getType

    public String getType()

The build output artifact's type. Valid values include:

- `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

- `NO_ARTIFACTS`: The build project will not produce any build output.

- `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Returns:
  The build output artifact's type. Valid values include:

  - `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

  - `NO_ARTIFACTS`: The build project will not produce any build output.

  - `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

See Also:
  `ArtifactsType`

#### withType

    public ProjectArtifacts withType(String type)

The build output artifact's type. Valid values include:

- `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

- `NO_ARTIFACTS`: The build project will not produce any build output.

- `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Parameters:
  `type` - The build output artifact's type. Valid values include:

  - `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

  - `NO_ARTIFACTS`: The build project will not produce any build output.

  - `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ArtifactsType`

#### setType

    public void setType(ArtifactsType type)

The build output artifact's type. Valid values include:

- `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

- `NO_ARTIFACTS`: The build project will not produce any build output.

- `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Parameters:
  `type` - The build output artifact's type. Valid values include:

  - `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

  - `NO_ARTIFACTS`: The build project will not produce any build output.

  - `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

See Also:
  `ArtifactsType`

#### withType

    public ProjectArtifacts withType(ArtifactsType type)

The build output artifact's type. Valid values include:

- `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

- `NO_ARTIFACTS`: The build project will not produce any build output.

- `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Parameters:
  `type` - The build output artifact's type. Valid values include:

  - `CODEPIPELINE`: The build project with have build output generated through AWS CodePipeline.

  - `NO_ARTIFACTS`: The build project will not produce any build output.

  - `S3`: The build project will store build output in Amazon Simple Storage Service (Amazon S3).

Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ArtifactsType`

#### setLocation

    public void setLocation(String location)

Information about the build output artifact location, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output locations instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the name of the output bucket. If `path` is not also specified, then `location` can also specify the path of the output artifact in the output bucket.

Parameters:
  `location` - Information about the build output artifact location, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output locations instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the name of the output bucket. If `path` is not also specified, then `location` can also specify the path of the output artifact in the output bucket.

#### getLocation

    public String getLocation()

Information about the build output artifact location, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output locations instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the name of the output bucket. If `path` is not also specified, then `location` can also specify the path of the output artifact in the output bucket.

Returns:
  Information about the build output artifact location, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output locations instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the name of the output bucket. If `path` is not also specified, then `location` can also specify the path of the output artifact in the output bucket.

#### withLocation

    public ProjectArtifacts withLocation(String location)

Information about the build output artifact location, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output locations instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the name of the output bucket. If `path` is not also specified, then `location` can also specify the path of the output artifact in the output bucket.

Parameters:
  `location` - Information about the build output artifact location, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output locations instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the name of the output bucket. If `path` is not also specified, then `location` can also specify the path of the output artifact in the output bucket.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setPath

    public void setPath(String path)

Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the path to the output artifact. If `path` is not specified, then `path` will not be used.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `NONE`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in the output bucket at `MyArtifacts/MyArtifact.zip`.

Parameters:
  `path` - Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the path to the output artifact. If `path` is not specified, then `path` will not be used.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `NONE`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in the output bucket at `MyArtifacts/MyArtifact.zip`.

#### getPath

    public String getPath()

Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the path to the output artifact. If `path` is not specified, then `path` will not be used.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `NONE`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in the output bucket at `MyArtifacts/MyArtifact.zip`.

Returns:
  Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the path to the output artifact. If `path` is not specified, then `path` will not be used.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `NONE`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in the output bucket at `MyArtifacts/MyArtifact.zip`.

#### withPath

    public ProjectArtifacts withPath(String path)

Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the path to the output artifact. If `path` is not specified, then `path` will not be used.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `NONE`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in the output bucket at `MyArtifacts/MyArtifact.zip`.

Parameters:
  `path` - Along with `namespaceType` and `name`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the path to the output artifact. If `path` is not specified, then `path` will not be used.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `NONE`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in the output bucket at `MyArtifacts/MyArtifact.zip`.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setNamespaceType

    public void setNamespaceType(String namespaceType)

Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, then valid values include:

  - `BUILD_ID`: Include the build ID in the location of the build output artifact.

  - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Parameters:
  `namespaceType` - Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, then valid values include:

    - `BUILD_ID`: Include the build ID in the location of the build output artifact.

    - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

See Also:
  `ArtifactNamespace`

#### getNamespaceType

    public String getNamespaceType()

Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, then valid values include:

  - `BUILD_ID`: Include the build ID in the location of the build output artifact.

  - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Returns:
  Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, then valid values include:

    - `BUILD_ID`: Include the build ID in the location of the build output artifact.

    - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

See Also:
  `ArtifactNamespace`

#### withNamespaceType

    public ProjectArtifacts withNamespaceType(String namespaceType)

Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, then valid values include:

  - `BUILD_ID`: Include the build ID in the location of the build output artifact.

  - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Parameters:
  `namespaceType` - Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, then valid values include:

    - `BUILD_ID`: Include the build ID in the location of the build output artifact.

    - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ArtifactNamespace`

#### setNamespaceType

    public void setNamespaceType(ArtifactNamespace namespaceType)

Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, then valid values include:

  - `BUILD_ID`: Include the build ID in the location of the build output artifact.

  - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Parameters:
  `namespaceType` - Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, then valid values include:

    - `BUILD_ID`: Include the build ID in the location of the build output artifact.

    - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

See Also:
  `ArtifactNamespace`

#### withNamespaceType

    public ProjectArtifacts withNamespaceType(ArtifactNamespace namespaceType)

Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, then valid values include:

  - `BUILD_ID`: Include the build ID in the location of the build output artifact.

  - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Parameters:
  `namespaceType` - Along with `path` and `name`, the pattern that AWS CodeBuild will use to determine the name and location to store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, then valid values include:

    - `BUILD_ID`: Include the build ID in the location of the build output artifact.

    - `NONE`: Do not include the build ID. This is the default if `namespaceType` is not specified.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ArtifactNamespace`

#### setName

    public void setName(String name)

Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the name of the output artifact object.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Parameters:
  `name` - Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the name of the output artifact object.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

#### getName

    public String getName()

Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the name of the output artifact object.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Returns:
  Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the name of the output artifact object.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

#### withName

    public ProjectArtifacts withName(String name)

Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, this is the name of the output artifact object.

For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Parameters:
  `name` - Along with `path` and `namespaceType`, the pattern that AWS CodeBuild will use to name and store the output artifact, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output names instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, this is the name of the output artifact object.

  For example, if `path` is set to `MyArtifacts`, `namespaceType` is set to `BUILD_ID`, and `name` is set to `MyArtifact.zip`, then the output artifact would be stored in `MyArtifacts/build-ID/MyArtifact.zip`.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setPackaging

    public void setPackaging(String packaging)

The type of build output artifact to create, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, valid values include:

  - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

  - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Parameters:
  `packaging` - The type of build output artifact to create, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, valid values include:

    - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

    - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

See Also:
  `ArtifactPackaging`

#### getPackaging

    public String getPackaging()

The type of build output artifact to create, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, valid values include:

  - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

  - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Returns:
  The type of build output artifact to create, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, valid values include:

    - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

    - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

See Also:
  `ArtifactPackaging`

#### withPackaging

    public ProjectArtifacts withPackaging(String packaging)

The type of build output artifact to create, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, valid values include:

  - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

  - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Parameters:
  `packaging` - The type of build output artifact to create, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, valid values include:

    - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

    - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ArtifactPackaging`

#### setPackaging

    public void setPackaging(ArtifactPackaging packaging)

The type of build output artifact to create, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, valid values include:

  - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

  - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Parameters:
  `packaging` - The type of build output artifact to create, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, valid values include:

    - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

    - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

See Also:
  `ArtifactPackaging`

#### withPackaging

    public ProjectArtifacts withPackaging(ArtifactPackaging packaging)

The type of build output artifact to create, as follows:

- If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

- If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

- If `type` is set to `S3`, valid values include:

  - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

  - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Parameters:
  `packaging` - The type of build output artifact to create, as follows:

  - If `type` is set to `CODEPIPELINE`, then AWS CodePipeline will ignore this value if specified. This is because AWS CodePipeline manages its build output artifacts instead of AWS CodeBuild.

  - If `type` is set to `NO_ARTIFACTS`, then this value will be ignored if specified, because no build output will be produced.

  - If `type` is set to `S3`, valid values include:

    - `NONE`: AWS CodeBuild will create in the output bucket a folder containing the build output. This is the default if `packaging` is not specified.

    - `ZIP`: AWS CodeBuild will create in the output bucket a ZIP file containing the build output.

Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `ArtifactPackaging`

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public ProjectArtifacts clone()

Overrides:
  `clone` in class `Object`